﻿local dataobject = LibStub("LibDataBroker-1.1"):NewDataObject("Broker_Speed", {
	type = "data source",
	icon = "Interface\\Icons\\Ability_Rogue_Sprint.blp",
	label = "Speed",
	suffix = "%",
	value = 0,
})

local floor = math.floor
local format = string.format
local GetUnitSpeed = GetUnitSpeed
local speed
local function UpdateSpeed(frame,elapsed)
	local newspeed = GetUnitSpeed("player")
	if newspeed == speed then return end
	speed = newspeed

    if UnitOnTaxi("player") then
        dataobject.icon = "Interface\\CURSOR\\Taxi"
    elseif IsSwimming() then
        dataobject.icon = "Interface\\Icons\\Ability_Druid_AquaticForm"
    elseif IsFlying() then
        dataobject.icon = "Interface\\Icons\\Ability_Druid_FlightForm"
    elseif IsFalling() then
        dataobject.icon = "Interface\\Icons\\Spell_Magic_FeatherFall"
    elseif IsMounted() then
        dataobject.icon = "Interface\\Icons\\Ability_Mount_RidingHorse"
    else
        dataobject.icon = "Interface\\Icons\\Ability_Rogue_Sprint"
    end
    dataobject.value = floor(speed / 7 * 100 + 0.1)
    dataobject.text = dataobject.value .. dataobject.suffix
end

local frame = CreateFrame("Frame")
frame:SetScript("OnUpdate", UpdateSpeed)

